"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * コンバータ機能を提供するクラス。
 */
var Converter = /** @class */ (function () {
    function Converter() {
    }
    /**
     * エンティティをホバー可能に変換する。
     */
    Converter.asHoverable = function (e, opts) {
        var hoverableE = e;
        hoverableE.hoverable = true;
        hoverableE.touchable = true;
        hoverableE.hovered = hoverableE.hovered || new g.Trigger();
        hoverableE.unhovered = hoverableE.unhovered || new g.Trigger();
        if (opts) {
            if (opts.cursor)
                hoverableE.cursor = opts.cursor;
        }
        return hoverableE;
    };
    /**
     * エンティティのホバーを解除する。
     */
    Converter.asUnhoverable = function (e) {
        var hoverableE = e;
        delete hoverableE.hoverable;
        if (hoverableE.hovered && !hoverableE.hovered.destroyed()) {
            hoverableE.hovered.destroy();
            delete hoverableE.hovered;
        }
        if (hoverableE.unhovered && !hoverableE.unhovered.destroyed()) {
            hoverableE.unhovered.fire();
            hoverableE.unhovered.destroy();
            delete hoverableE.unhovered;
        }
        return hoverableE;
    };
    return Converter;
}());
exports.Converter = Converter;
